#ifndef AACS_AES_H
#define AACS_AES_H

#include <cstddef>  // for size_t

//aes

int calculate_subdev_proc_key(const unsigned char *dev_key, /*out*/ unsigned char *subdev_proc_key, unsigned char lmr);

int decrypt_c_value(const unsigned char *encrypted_c_value, const unsigned char *processing_key, /*out*/ unsigned char *decrypted_c_value, const unsigned char *uv, /*out*/ unsigned char *media_key);

int decrypt_verification_data(const unsigned char *encrypted_verification_data, const unsigned char *media_key, /*out*/ unsigned char *decrypted_verification_data);

int calculate_volume_unique_key(const unsigned char *volume_id, const unsigned char *media_key, /*out*/ unsigned char *decrypted_volumeid, /*out*/ unsigned char *volume_unqiue_key);

int decrypt_title_key(const unsigned char *encrypted_title_key, const unsigned char *volume_unqiue_key, const unsigned char *usage_rules, size_t length, /*out*/ unsigned char *decrypted_title_key);

int calculate_title_key_file_mac(const unsigned char *title_key_file, size_t length, const unsigned char *volume_unqiue_key, /*out*/ unsigned char *title_key_file_mac);

int calculate_title_key_file_hash(const unsigned char *title_key_file, size_t length, /*out*/ unsigned char *title_key_file_hash);

int calculate_volume_id_mac(const unsigned char *volume_id, size_t length, const unsigned char *bus_key, /*out*/ unsigned char *volume_id_mac);

#endif
