#ifndef ECDSA_H
#define ECDSA_H

#ifndef AACS_NO_ECDSA
//ecdsa
#include <openssl/ec.h>
#include <openssl/ecdsa.h>


EC_KEY *aacs_key();

EC_GROUP *aacs_group();

int aacs_set_cert(/*out*/ EC_KEY *key, const unsigned char *cert);

int aacs_verify(const unsigned char *cert, const unsigned char *signature, const unsigned char *nonce, const unsigned char *point);

int aacs_sign(const unsigned char *cert, const unsigned char *priv_key, /*out*/ unsigned char *signature, const unsigned char *nonce, const unsigned char *point);

int aacs_calculate_bus_key(const unsigned char *cert, const unsigned char *host_key, const unsigned char *drive_key_point, /*out*/ unsigned char *bus_key);
#endif

#endif
